var J = Object.defineProperty;
var V = (n, e, t) => e in n ? J(n, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : n[e] = t;
var l = (n, e, t) => (V(n, typeof e != "symbol" ? e + "" : e, t), t);
import { PlotController as q, CursorType as m, newScreenPoint as Y, OxyModifierKeys as b, OxyMouseButton as p, LineJoin as P, OxyColorHelper as c, FontWeights as O, newOxySize as j, ClippingRenderContext as G, round as I, isNullOrUndef as z, HorizontalAlignment as L, VerticalAlignment as F, StringHelper as Q, OxyImageEx as H, newOxyRect as R, OxyRectHelper as W, OxyRect_Empty as k, OxyColors as N, EdgeRenderingMode as K, SvgRenderContext as tt } from "oxyplot-js";
class $ {
  constructor() {
    l(this, "controller");
    l(this, "defaultController");
    l(this, "_zoomRectangle");
    l(this, "_model");
    l(this, "_isModelInvalidated", !1);
    l(this, "_updateDataFlag", !1);
    l(this, "_rendering", !1);
  }
  get actualController() {
    return this.controller ? this.controller : this.defaultController ? this.defaultController : (this.defaultController = new q(), this.defaultController);
  }
  get actualModel() {
    return this._model;
  }
  get model() {
    return this._model;
  }
  set model(e) {
    const t = this._model;
    this._model = e, this.onModelChanged(t, e);
  }
  onModelChanged(e, t) {
    e && e.attachPlotView(void 0), t && t.attachPlotView(this), this.invalidatePlot(!0);
  }
  invalidatePlot(e) {
    this._isModelInvalidated = !0, this._updateDataFlag = e || !1, this.render();
  }
  render() {
    const e = this._model;
    e && (this._isModelInvalidated && (e.update(this._updateDataFlag), this._isModelInvalidated = !1, this._updateDataFlag = !1), window.requestAnimationFrame(async () => this.renderSync()));
  }
  setClipboardText(e) {
    try {
      navigator.clipboard.writeText(e);
    } catch (t) {
      console.error(t);
    }
  }
  setCursorType(e) {
  }
  hideTracker() {
  }
  showTracker(e) {
  }
  hideZoomRectangle() {
    this._zoomRectangle = void 0;
  }
  showZoomRectangle(e) {
    this._zoomRectangle = e;
  }
  async renderSync() {
    if (this._model && !this._rendering) {
      this._rendering = !0;
      try {
        await this.renderOverride(this._model);
      } finally {
        this._rendering = !1;
      }
    }
  }
}
function _(n) {
  return {
    position: Y(n.offsetX, n.offsetY),
    modifierKeys: nt(n),
    handled: !1
  };
}
function et(n) {
  const e = _(n);
  return e.clickCount = n.detail, e.changedButton = ot(n), e;
}
function it(n) {
  const e = _(n);
  return e.delta = n.deltaY != 0 ? -n.deltaY : n.deltaX, e;
}
function nt(n) {
  let e = b.None;
  return n.ctrlKey && (e |= b.Control), n.shiftKey && (e |= b.Shift), n.altKey && (e |= b.Alt), n.metaKey && (e |= b.Windows), e;
}
function ot(n) {
  return n.button === 0 ? p.Left : n.button === 1 ? p.Middle : n.button === 2 ? p.Right : n.button === 3 ? p.XButton1 : n.button === 4 ? p.XButton2 : p.None;
}
function A(n) {
  switch (n) {
    case m.Default:
      return "default";
    case m.Pan:
      return "grab";
    case m.ZoomRectangle:
      return "nwse-resize";
    case m.ZoomHorizontal:
      return "ew-resize";
    case m.ZoomVertical:
      return "ns-resize";
    default:
      return "default";
  }
}
function U(n, e) {
  n.addEventListener("contextmenu", function(t) {
    t.preventDefault();
  }), new ResizeObserver(() => {
    e.invalidatePlot(!1);
  }).observe(n), n.onmousedown = (t) => {
    e.actualController.handleMouseDown(e, et(t));
  }, n.onmousemove = (t) => {
    e.actualController.handleMouseMove(e, _(t));
  }, n.onmouseup = (t) => {
    e.actualController.handleMouseUp(e, _(t));
  }, n.onmouseenter = (t) => {
    e.actualController.handleMouseEnter(e, _(t));
  }, n.onmouseleave = (t) => {
    e.actualController.handleMouseLeave(e, _(t));
  }, n.onwheel = (t) => {
    e.actualController.handleMouseWheel(e, it(t));
  };
}
let S = null;
function st() {
  if (S)
    return S;
  const n = document.createElement("canvas");
  if (S = n == null ? void 0 : n.getContext("2d"), !S)
    throw new Error("Could not get canvas context");
  return S;
}
let B = null;
const rt = (n, e, t) => (B || (B = new D()), B.convertFont(n, e, t || O.Normal));
function X(n) {
  n = n || st();
  function e(t, i, o, s) {
    if (!n)
      throw new Error("Could not get canvas context");
    n.font = rt(i, o, s);
    const r = n.measureText(t);
    return j(r.width, o);
  }
  return {
    measureText: e
  };
}
class D {
  convertLineJoin(e) {
    switch (e = e || P.Miter, e) {
      case P.Miter:
        return "miter";
      case P.Bevel:
        return "bevel";
      case P.Round:
        return "round";
    }
  }
  convertStrokeOrFillStyle(e) {
    return c.toRgba(e);
  }
  convertFont(e, t, i) {
    let o = "";
    return (i || O.Normal) > O.Normal && (o += "bold "), o += `${t || 12}px `, e && (o += `"${e}" `), o.trim();
  }
}
class lt {
  constructor() {
    l(this, "cache", /* @__PURE__ */ new Map());
  }
  get(e) {
    return this.cache.get(e);
  }
  set(e, t) {
    this.cache.set(e, t);
  }
  clear(e) {
    e ? this.cache.delete(e) : this.cache.clear();
  }
}
let Z = new lt();
function at() {
  return Z;
}
function ut(n) {
  Z = n;
}
class ht extends G {
  constructor(t) {
    super();
    l(this, "ctx");
    l(this, "_textMeasurer");
    l(this, "styleConverter", new D());
    l(this, "_ctxInitStyles");
    l(this, "_renderContextImageCacheService");
    this.canvas = t;
    const i = t.getContext("2d");
    if (!i)
      throw new Error("Could not get canvas context");
    this.ctx = i, this._ctxInitStyles = {
      fillStyle: i.fillStyle,
      strokeStyle: i.strokeStyle,
      lineJoin: i.lineJoin,
      lineWidth: i.lineWidth
    }, this._renderContextImageCacheService = at(), this._textMeasurer = X(i);
  }
  async drawImage(t, i, o, s, r, a, d, h, u, f, g) {
    if (f <= 0)
      return;
    this.resetStyles();
    const x = this.ctx, v = await this.getOrCreateImage(t, () => {
      const M = new Blob([Uint8Array.from(t.data)], { type: "image/png" });
      return createImageBitmap(M);
    });
    x.imageSmoothingEnabled = g, x.drawImage(
      v,
      i,
      o,
      s,
      r,
      I(a, 0),
      I(d, 0),
      I(h, 0),
      I(u, 0)
    );
  }
  /**
   * Draws line segments.
   * @param points The points.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawLineSegments(t, i, o, s, r, a) {
    if (t.length < 2 || c.isInvisible(i) || o == 0)
      return;
    this.resetStyles();
    const d = this.ctx;
    d.beginPath(), this.applyLineStyle(i, o, s, r, a);
    for (let h = 0; h < t.length; h += 2) {
      const u = t[h], f = t[h + 1];
      this.drawPoints([u, f]);
    }
    d.stroke();
  }
  async drawLine(t, i, o, s, r, a) {
    if (t.length < 2 || c.isInvisible(i) || o == 0)
      return;
    this.resetStyles();
    const d = this.ctx;
    d.beginPath(), this.applyLineStyle(i, o, s, r, a), this.drawPoints(t), d.stroke();
  }
  /**
   * Draws a polygon.
   * @param points The points.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygon(t, i, o, s, r, a, d) {
    if (c.isInvisible(i) && !(c.isVisible(o) || s <= 0) || t.length < 2)
      return;
    this.resetStyles();
    const h = this.ctx;
    h.beginPath(), this.applyPolygonStyle(i, o, s, r, a, d), this.drawPoints(t), h.closePath(), c.isVisible(i) && h.fill(), c.isVisible(o) && s > 0 && h.stroke();
  }
  /**
   * Draws multiple polygons.
   * @param polygons The polygons.
   * @param fill The fill color.
   * @param stroke The stroke color.
   * @param thickness The thickness.
   * @param edgeRenderingMode The edge rendering mode.
   * @param dashArray The dash array.
   * @param lineJoin The line join.
   */
  async drawPolygons(t, i, o, s, r, a, d) {
    if (c.isInvisible(i) && !(c.isVisible(o) || s <= 0) || t.length === 0)
      return;
    this.resetStyles();
    const h = this.ctx;
    this.applyPolygonStyle(i, o, s, r, a, d);
    for (const u of t)
      u.length < 2 || (h.beginPath(), this.drawPoints(u), h.closePath(), c.isVisible(i) && h.fill(), c.isVisible(o) && s > 0 && h.stroke());
  }
  /**
   * Draws the text.
   * @param p The position of the text.
   * @param text The text.
   * @param fill The fill color.
   * @param fontFamily The font family.
   * @param fontSize Size of the font.
   * @param fontWeight The font weight.
   * @param rotation The rotation angle.
   * @param horizontalAlignment The horizontal alignment.
   * @param verticalAlignment The vertical alignment.
   * @param maxSize The maximum size of the text.
   */
  async drawText(t, i, o, s, r, a, d, h, u, f) {
    if (!i || c.isInvisible(o))
      return;
    z(h) && (h = L.Left), z(u) && (u = F.Top), this.resetStyles();
    const g = this.ctx;
    r = r || 12, a = a || O.Normal, this.applyTextStyle(o, s, r, a), g.save(), g.translate(t.x, t.y), d && g.rotate(d * (Math.PI / 180));
    const x = Q.splitLines(i), v = [];
    for (const y of x) {
      const w = this.measureText(y, s, r, a);
      v.push(w);
    }
    const M = v.reduce((y, w) => y + w.height, 0);
    let C = 0;
    g.textBaseline = "middle", u === F.Top ? C = 0 : u === F.Middle ? C = -M / 2 : u === F.Bottom && (C = -M);
    for (let y = 0; y < x.length; y++) {
      const w = x[y];
      let E = 0;
      const T = v[y];
      h === L.Center ? E = -T.width / 2 : h === L.Right && (E = -T.width), g.fillText(w, E, C + T.height / 2, f == null ? void 0 : f.width), C += T.height;
    }
    g.restore();
  }
  measureText(t, i, o, s) {
    return this._textMeasurer.measureText(t, i, o, s);
  }
  setClip(t) {
    this.ctx.save();
    const i = new Path2D();
    i.rect(t.left, t.top, t.width, t.height), this.ctx.clip(i);
  }
  resetClip() {
    this.ctx.restore();
  }
  resetStyles() {
    const t = this.ctx;
    t.setLineDash([]), Object.assign(t, this._ctxInitStyles);
  }
  applyLineStyle(t, i, o, s, r) {
    const a = this.ctx;
    s && s.length > 0 && a.setLineDash(s), a.lineWidth = i, a.lineJoin = this.styleConverter.convertLineJoin(r), a.strokeStyle = this.styleConverter.convertStrokeOrFillStyle(t);
  }
  applyPolygonStyle(t, i, o, s, r, a) {
    c.isVisible(i) && o > 0 && this.applyLineStyle(i, o, s, r, a), c.isVisible(t) && (this.ctx.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t));
  }
  applyTextStyle(t, i, o, s) {
    const r = this.ctx;
    r.fillStyle = this.styleConverter.convertStrokeOrFillStyle(t), r.font = this.styleConverter.convertFont(i, o, s);
  }
  drawPoints(t) {
    this.ctx.moveTo(t[0].x, t[0].y);
    for (let i = 1; i < t.length; i++) {
      const o = t[i];
      this.ctx.lineTo(o.x, o.y);
    }
  }
  async getOrCreateImage(t, i) {
    const o = H.from(t).getHashCode().toString(), s = this._renderContextImageCacheService.get(o);
    if (s)
      return Promise.resolve(s);
    const r = await i();
    return this._renderContextImageCacheService.set(o, r), r;
  }
}
class gt extends $ {
  constructor(t) {
    super();
    l(this, "_view");
    l(this, "_tooltip");
    l(this, "_renderContext");
    l(this, "_drawCtx");
    l(this, "_styleConverter", new D());
    if (this._view = t, this.setupCanvas(t), this._drawCtx = this._view.getContext("2d"), !this._drawCtx)
      throw new Error("Could not get 2d context");
    this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", this._tooltip.style.transition = "transform 0.2s ease, top 0.2s ease, left 0.2s ease", document.body.appendChild(this._tooltip), this._renderContext = new ht(this._view), U(this._view, this), new ResizeObserver(() => {
      this.setupCanvas(t);
    }).observe(t);
  }
  setupCanvas(t) {
    const i = window.devicePixelRatio || 1, o = t.getBoundingClientRect();
    o.width === 0 || o.height === 0 || (t.width = o.width * i, t.height = o.height * i);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return R(0, 0, this._view.width, this._view.height);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const i = t.toString() || "";
    if (i.trim().length === 0)
      return;
    const { top: o, left: s } = this._view.getBoundingClientRect();
    this._tooltip.innerText = i, this._tooltip.style.top = `${o + t.position.y}px`, this._tooltip.style.left = `${s + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = A(t);
  }
  async renderOverride(t) {
    this._drawCtx = this._view.getContext("2d");
    const i = window.devicePixelRatio || 1;
    this._drawCtx.scale(i, i);
    const o = this._view;
    if (this._drawCtx.reset(), c.isUndefined(t.background) || (this._drawCtx.fillStyle = this._styleConverter.convertStrokeOrFillStyle(t.background), this._drawCtx.fillRect(0, 0, o.width, o.height)), await t.render(this._renderContext, R(0, 0, o.width, o.height)), this._zoomRectangle && W.equals(this._zoomRectangle, k)) {
      const s = c.parse("#40FFFF00"), r = N.Black;
      await this._renderContext.drawRectangle(this._zoomRectangle, s, r, 1, K.Automatic);
    }
  }
}
class yt extends $ {
  constructor(t) {
    super();
    l(this, "_view");
    l(this, "_tooltip");
    //private readonly _drawCtx: HTMLElement
    l(this, "textMeasurer");
    this._view = t, this.textMeasurer = X(), this._tooltip = document.createElement("div"), this._tooltip.style.position = "absolute", this._tooltip.style.zIndex = "100", this._tooltip.style.backgroundColor = "#FFFFA0E0", this._tooltip.style.border = "1px solid black", this._tooltip.style.padding = "8px", this._tooltip.style.visibility = "hidden", this._tooltip.style.pointerEvents = "none", document.body.appendChild(this._tooltip), U(this._view, this);
  }
  get tooltip() {
    return this._tooltip;
  }
  get clientArea() {
    return R(0, 0, this._view.clientWidth, this._view.clientHeight);
  }
  hideTracker() {
    this._tooltip.style.visibility = "hidden";
  }
  showTracker(t) {
    if (!(t != null && t.position))
      return;
    const i = t.toString() || "";
    if (i.trim().length === 0)
      return;
    const o = this._view.offsetTop, s = this._view.offsetLeft;
    this._tooltip.innerText = i, this._tooltip.style.top = `${o + t.position.y}px`, this._tooltip.style.left = `${s + t.position.x}px`, this._tooltip.style.visibility = "visible";
  }
  setCursorType(t) {
    this._view.style.cursor = A(t);
  }
  async renderOverride(t) {
    const i = this._view;
    this._view.innerHTML = "";
    const o = new tt(
      i.clientWidth,
      i.clientHeight,
      !0,
      this.textMeasurer,
      t.background
    );
    if (c.isUndefined(t.background) || (this._view.style.backgroundColor = t.background.toString()), await t.render(o, R(0, 0, i.clientWidth, i.clientHeight)), this._zoomRectangle && W.equals(this._zoomRectangle, k)) {
      const s = c.parse("#40FFFF00"), r = N.Black;
      await o.drawRectangle(this._zoomRectangle, s, r, 1, K.Automatic);
    }
    o.complete(), this._view.innerHTML = o.getXml();
  }
}
export {
  gt as CanvasPlotView,
  D as OxyStyleToCanvasStyleConverter,
  yt as SvgPlotView,
  $ as WebPlotViewBase,
  X as canvasTextMeasurer,
  at as getRenderContextImageCacheService,
  ut as setRenderContextImageCacheService
};
